<?php
namespace Pinpoint\DeliveryDate\Block\Adminhtml\DisallowedDate\Edit;

use Magento\Backend\Model\UrlInterface;
use Magento\Framework\App\RequestInterface;

class GenericButton
{
    /**
     * @var UrlInterface
     */
    protected UrlInterface $urlBuilder;

    /**
     * @var RequestInterface
     */
    protected RequestInterface $request;

    /**
     * GenericButton constructor.
     * @param UrlInterface     $urlBuilder
     * @param RequestInterface $request
     */
    public function __construct(
        UrlInterface $urlBuilder,
        RequestInterface $request
    ) {
        $this->urlBuilder = $urlBuilder;
        $this->request = $request;
    }

    /**
     * @return string
     */
    public function getBackUrl(): string
    {
        return $this->getUrl('*/*/list');
    }

    /**
     * @return string
     */
    public function getDeleteUrl(): string
    {
        return $this->getUrl('*/*/delete', ['id' => $this->getObjectId()]);
    }

    /**
     * @param string $route
     * @param array  $params
     * @return string
     */
    public function getUrl(string $route = '', array $params = []): string
    {
        return $this->urlBuilder->getUrl($route, $params);
    }

    /**
     * @return mixed
     */
    public function getObjectId(): mixed
    {
        return $this->request->getParam('id');
    }
}